Two Sum – LeetCode
Given an array of integers nums
and an integer target
, return indices of the two numbers such that they add up to target
.
You may assume that each input would have exactly one solution, and you may not use the same element twice.
You can return the answer in any order.
Example 1:
Input: nums = [2,7,11,15], target = 9 Output: [0,1] Output: Because nums[0] + nums[1] == 9, we return [0, 1].
Example 2:
Input: nums = [3,2,4], target = 6 Output: [1,2]
Example 3:
Input: nums = [3,3], target = 6 Output: [0,1]
Constraints:
2 <= nums.length <= 104
-109 <= nums[i] <= 109
-109 <= target <= 109
- Only one valid answer exists.
Solution
Approach 1: Brute Force
class Solution { public int[] twoSum(int[] nums, int target) { for(int i = 0;i < nums.length; i++){ for(int j = i+1;j < nums.length; j++){ if(nums[i]+nums[j] == target) return new int[]{i,j}; } } throw new IllegalArgumentException("No two sum solution"); } }
Time complexity – O(n2) Space complexity – O(1)
Approach 2: Using HashMap to store difference with index
class Solution { public int[] twoSum1(int[] nums, int target) { HashMap<Integer,Integer> preComputed = new HashMap<>(); for(int i = 0;i< nums.length;i++){ if(preComputed.containsKey(target-nums[i])){ return new int[]{preComputed.get(target-nums[i]), i}; } preComputed.put(nums[i],i); } throw new IllegalArgumentException("No two sum solution"); } }
Time complexity – O(n) Space complexity – O(n)
Advertisement